Page MenuHomePhabricator

Differential-to-Asana integration, like with JIRA
Closed, WontfixPublic

Description

At my company we use Asana for tracking tasks.

When I put up a Differential review for an Asana task, I want to link to the Asana task because the Asana task will often have a description and discussion that provides more context for reviewers looking at the Differential review. What I end up having to do is manually linking to the Asana task in the Differential review summary.

We also want the Asana task to stay updated with the state of the Differential review (e.g. created, submitted) so we can better track the progress of the task. For example, we assign Asana tasks a tag to indicate the task's current status. This allows us to create queries in Asana to monitor the progress of a project by seeing which tasks are under review, have been submitted, deployed/completed. Currently we have to manually add add/update the tag on the Asana task after we create a Differential review and when the Differential review is submitted to accomplish this.

Event Timeline

mduan created this task.Dec 23 2015, 11:17 PM
chad added a subscriber: chad.Dec 23 2015, 11:26 PM

Are you using the current integration?

mduan added a comment.EditedDec 24 2015, 12:52 AM

The existing Asana integration is for creating an Asana when you create a Differential review for the purpose of reviewing the Differential.

I want something more inline with the JIRA integration which adds a "JIRA Issue" field in the commit message when you do arc diff that serves to link the Differential review to existing JIRA issue(s).

I've actually forked Phabricator and built out a prototype for this feature request by replicating the JIRA behavior above to work for Asana. I was wondering if that's something that would be worth incorporating in the main Phabricator repo.

Facebook has this exact kind of integration with their internal tasks tool - it's extremely useful for communicating the engineering progress of a task to non-technical team members, and it builds an explicit relationship between tasks and diffs, which very often go hand in hand. Maniphest and JIRA both already have this type of integration with Differential - it would be great to have the same thing for Asana.

This has been on my personal wishlist for a long time so I'm excited to see @mduan willing to run with it :)

avivey renamed this task from Integrating Differential revisions with Asana tasks to Differential-to-Asana integration, like with JIRA.Dec 24 2015, 11:47 PM
epriestley triaged this task as Wishlist priority.Jan 2 2016, 12:12 AM
epriestley added a subscriber: epriestley.

To set expectations, this is a very low priority for the upstream. Most prior Asana/JIRA work in this vein has been for paying customers (see Prioritization).

I'd tentatively accept work here from an established community member (like D9858 expanded JIRA support) under the "Rise to Prominence" clause in Contributing Code, but I expect any changes here to have a substantial maintenance cost in the long term and am very wary about accepting them from a new contributor who doesn't have history with the project ("please maintain this external integration" is generally a "white elephant" patch). See also T3179 for general project stance.

A workaround which is easy, straightforward, available today and fully supported by the upstream is to use Maniphest instead of Asana.

You could also publish your changes yourself and list them on Community Resources, although writing them as a pure extension (vs by patching the existing Asana integration) may be challenging. See also T10038 / T5055.

Got it - those are fair points. We'll maintain a fork of Phabricator with this Asana integration, so please ping me if you'd like to reference it at some point in the future!

turadg added a subscriber: turadg.Apr 9 2016, 7:33 PM
epriestley closed this task as Wontfix.Jan 31 2018, 3:48 PM
epriestley claimed this task.

Because of the high degree of complexity there's basically zero chance we'll ever build this without active customer interest, and we have none today. Closing this until interest arises.

jimbru added a subscriber: jimbru.May 9 2018, 6:53 AM